#define _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <vector>
#include <utility>
#include <algorithm>
#include <functional>
#include <set>
#include <map>
#include <cmath>
#include <queue>
#include <memory.h>
#include <sstream>
#include <cassert>
#include <ctime>
#include <complex>
#include <unordered_map>
#include <unordered_set>
#include <bitset>

using namespace std;

typedef long long int64;
typedef unsigned long long uint64;
typedef pair<int, int> pii;
typedef pair<int64, int64> pll;
typedef pair<int64, int> pli;

const int INF = (int)(1e9+1e5);
const int64 LINF = (int64)(4e18);
const double EPS = 1e-10;
const int MOD = (int)1e9 + 7;
#define sq(x) ((x)*(x))
#define FAIL() ((*(int*)0)++)
#define y0 y00

int t;

const int MAXN = 55;

int n;
int64 d[MAXN][MAXN], dist[MAXN][MAXN];

void init()
{
	scanf ("%d", &n);
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= n; j++)
		{
			scanf ("%lld", &d[i][j]);
		}
	}
}

void floyd()
{
	memcpy(dist, d, sizeof(d));
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= n; j++)
		{
			for (int h = 1; h <= n; h++)
			{
				if (dist[j][i] == -1 || dist[i][h] == -1)
				{
					continue;
				}
				int64 sum = dist[j][i] + dist[i][h];
				if (sum < dist[j][h] || dist[j][h] == -1)
				{
					dist[j][h] = sum;
				}
			}
		}
	}
//	for (int i = 1; i <= n; i++)
//	{
//		for (int j = 1; j <= n; j++)
//		{
//			printf("%d ", dist[i][j]);
//		}
//		printf("\n");
//	}
}

void solve()
{
	init();
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j < i; j++)
		{
			if (d[i][j] != -1)
			{
				d[i][j] <<= 1;
			}
		}
	}
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j < i; j++)
		{
			d[j][i] = d[i][j];
		}
	}
	floyd();
	int64 ans = LINF;
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j < i; j++)
		{
			if (d[i][j] == -1)
			{
				continue;
			}
			int64 mx = 0;
			vector <pli> ev;
			for (int h = 1; h <= n; h++)
			{
				if (h == i || h == j)
				{
					continue;
				}
				mx = max(mx, dist[i][h]);
				int64 d1 = dist[i][h];
				int64 d2 = dist[j][h] + d[i][j];
				int64 t = max((d2 - d1 + 1) / 2LL, 0LL);
				if (t <= d[i][j])
				{
					ev.push_back(pli(t, h));
					//printf("%lld %d\n", t, h);
				}
			}
			int64 cur = mx <= d[i][j] ? (mx + d[i][j]) / 2LL : mx;
			ans = min(ans, cur);
			//printf("%d %d %lld %lld\n", i, j, 0LL, (cur + d[i][j]) >> 1);
			sort (ev.begin(), ev.end());
			for (int h = 0; h < (int)ev.size(); h++)
			{
				int64 di = 0LL, dj = 0LL;
				int64 t = ev[h].first;
				//int v = ev[h].second;
				for (int g = 1; g <= n; g++)
				{
					if (dist[g][j] + d[i][j] - t <= dist[g][i] + t)
					{
						dj = max(dj, dist[j][g]);
					}
					else
					{
						di = max(di, dist[i][g]);
					}
				}
				t = (di + d[i][j] + dj) / 2LL - di;
				t = max(t, 0LL);
				t = min(t, d[i][j]);
				cur = max(di + t, dj + d[i][j] - t);
				//printf("%d %d %lld %lld\n", i, j, t, cur);
				ans = min(ans, cur);
			}
		}
	}
	double an = double(ans) / 2.0;
	printf("%.20lf\n", an);
}

int main()
{
	//srand(time(0)); testgen(10, 5, 30);
    ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef _MY_DEBUG
    freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
#endif
    double st = clock();
    int te = 1;
    scanf ("%d", &te);
    for (t = 1; t <= te; t++)
    {
    	solve();
    }

    //fprintf(stderr, "%.3lf\n", (clock() - st) / CLOCKS_PER_SEC);
    return 0;
}

