#!/usr/bin/python

import simplejson as json
from sys import stdin, stderr, stdout
import traceback

samples = 2
try:
    testData = json.load(stdin)["tests"]

    passed = 0
    total = 0
    for data in testData:
        total += 1
        try:
            message = data["message"]
        except Exception as e:
            message = "notok 0"

        verdict, points = message.split()[0:2]

        if total > samples and verdict == "ok":
            passed += 1
        
    if total > samples:
        points = int( (100 * passed) / (total - samples) )
    else:
        points = 0
    stdout.write(str(points) + '\n')

except Exception as e:
    stdout.write('-1\n')
    traceback.print_exc(file=stderr)
